/* this program converts normal text into a fil which can be included
   into a string definition of a c program and printed.
   Hence the text will be permanantly incorporated into the c-program.

  It is used in gaspan in the routine shownews in order
  to list the changes with respect to previous versions.

  F. Riess, Juli 2004
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define DEFAULTOUT = "message.h"

int main(int argc, char **argv)
{
  char text[120], *filep;
  int i;
  FILE *fpein = NULL, *fpaus;

  switch (argc)
  {
    case 2: filep = argv[1];
            fpein = stdin; 
            break;
    case 3: filep = argv[2];
            if((fpein = fopen(argv[1], "r")) == NULL)
	    {
              fprintf(stderr,"--> can not read file %s\n", argv[1]);
	      exit(EXIT_FAILURE);
            }
            break;
    default: filep = "message.h";
             fpein = stdin;
  }
  if((fpaus = fopen(filep, "w")) == NULL)
  {
     fprintf(stderr, "converttext: can not write into file %s\n", filep);
     exit(EXIT_FAILURE);
  }
  fputc('"', fpaus);
  while(fgets(text, 100, fpein) != NULL)
  {
    for(i = 0; i <  100 && text[i]; ++i)
    {
       if(text[i] == '"') fputc('\\', fpaus);
       if(text[i] == '\n')
       {
         fputc('\\', fpaus); fputc('n', fpaus); fputc('\\', fpaus); fputc('\n', fpaus);
         break;
       }
       else fputc(text[i], fpaus);
    }
  }
  fputc('"', fpaus); fputc('\n', fpaus);
  fclose(fpaus);
  exit(EXIT_SUCCESS);
}
