	logical function gasber()
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c  $Id: gasber.f,v 3.6 2005/01/25 09:13:02 friedrich Exp $
c  routine selektiert fitbereich
c  28.02.00  eliminate dependence of fitregion from maxch if
c            lastch -minch < FITREG
c  11.09.86  vax version
c  08.09.78  f. riess
c------------------------------------------------------------------
	implicit none

	include 'gasctr.icl'
	include 'gaseic.icl'
	include 'gasfil.icl'
	include 'gasfit.icl'
	include 'gaspar.icl'
	include 'gaspea.icl'
	include 'gasspe.icl'

        character*(*) TGASBER, NOPEAKS, TOOMANY, MINGEMAX, OUTSIDE, GTFITREG
        parameter (TGASBER = 'GASBER: ')
        parameter (NOPEAKS = '(a,''no peaks found in region ['',i6,''-'',i6,'']'')')
        parameter (TOOMANY = '(a,''too many lines in region ['',i6,''-'',i6,'']: ('',
     $    i3'' >''i3,'')'')')
        parameter (MINGEMAX = '(a,''limits of region in wrong sequence: '',2i7)')
        parameter (OUTSIDE = '(a,''region in list outside of fit-region: '',i6,'' < '',i6,'' or'',
     $    i6'' >''i6,'')'')') 
        parameter (GTFITREG = '(a,''region in list too large ('',i5,'' >'',i5)')
c	logical isensw
	integer gasspc, gaserr
	integer i, j, l, npeakt, nr
	real*8 poly
	real*8 fwid, widp, x, xwid, y, t1, t2

	npeakt = PEAKTOT
	if(ressearch .and. .not.peaklist) npeakt = 7*PEAKTOT/9
        gasber = .FALSE.
        nr = 0
        kpeaks = 0
        if(linepo.ge.maxlin) return
c  treat first the easy cases:
c  but: the number of peaks in the region must be less than npeakt 
c  highest priority:  fit - command,
        if(onefitregion) then
          minreg = minch
          maxreg = maxch
          if(maxreg - minreg + 1.gt.FITREG) return ! should not happen
          do i = 1+linepo, maxlin
            if(peak(i).ge.minreg .and. peak(i).le.maxreg) then
              nr = nr + 1
              peak(nr) = peak(i)
              dpeak(nr) = dpeak(i)
              area(nr) = area(i)
              darea(nr) = darea(i)
              width(nr) = width(i)
            endif
	  enddo
          if(nr.gt.npeakt) then
            write(*, TOOMANY) TGASBER, minreg, maxreg, nr, npeakt
            return
          endif
          if(nr.eq.0) then
            if(lpa) write(3, NOPEAKS) TGASBER, minreg, maxreg
            write(*, NOPEAKS) TGASBER, minreg, maxreg
            return
          endif
          kpeaks = nr
          maxlin = kpeaks
          backdeg = -1
	  x = 0.5*(peak(1) + peak(nr))
          wids = poly(x,ndw,aws)
          nerr = 0  ! end of onefitregion
c
c  next priority:  list of regions
        else if(peak(linepo + 1).lt.0) then 
          j = linepo + 1
          minreg = -peak(j)
          maxreg = area(j)
          if(minreg.ge.maxreg) then
            if(lpa) write(3, MINGEMAX) TGASBER, minreg, maxreg
            if(interactiv) write(*, MINGEMAX) TGASBER, minreg, maxreg
            return
          elseif(minreg.lt.minch .or. maxreg.gt.maxch) then
            if(lpa) write(3, OUTSIDE) TGASBER, minreg, maxreg, minch, maxch
            if(interactiv) write(3, OUTSIDE) TGASBER, minreg, maxreg, minch, maxch
            return
          else if(maxreg - minreg + 1.gt.FITREG) then
            if(lpa) write(3, GTFITREG) TGASBER, maxreg-minreg+1, FITREG
            if(interactiv) write(3, GTFITREG) TGASBER, maxreg-minreg+1, FITREG
            return
          else
	    backdeg = -1
            if(width(j).ge.0.) backdeg = width(j)+0.001
            i = j + 1
            do while(i.le.maxlin .and. peak(i).gt.0 .and. peak(i).lt.maxreg)
              nr = nr + 1
              i = i + 1
            enddo
            if(nr.gt.npeakt) then
              if(lpa) write(3, TOOMANY) TGASBER, minreg, maxreg, nr, npeakt
              if(interactiv) write(*, TOOMANY) TGASBER, minreg, maxreg, nr, npeakt
              return
            else if(nr.eq.0) then
              if(lpa) write(3, NOPEAKS) TGASBER, minreg, maxreg
              if(interactiv) write(3, NOPEAKS) TGASBER, minreg, maxreg
              return
            else
              kpeaks = nr
              x = 0.5*(peak(j + 1) + peak(j + nr))
              wids = poly(x,ndw,aws)
              nerr = 0
              linepo = linepo + 1
           endif
          endif !  else if(peak(linepo + 1).lt.0) 
c
c 3. fitregion less than FITREG
        else if(maxch - minch + 1.le.FITREG) then
          minreg = minch
          maxreg = maxch
          backdeg = -1
          j = linepo + 1
          do while(j.le.maxlin .and. peak(j).gt.0)
            nr = nr + 1
            j = j + 1 
          enddo
          if(nr.le.npeakt) then !  accept only if # of peaks are within limit
           kpeaks = nr
           maxlin = kpeaks
           backdeg=-1
	   x = 0.5*(peak(1) + peak(nr))
           wids=poly(x,ndw,aws)
           nerr = 0
          endif
        endif
c        if(nr.gt.0) then
c          kpeaks = nr
c          maxlin = kpeaks
c          irange = maxreg - minreg + 1
c	  x = 0.5*(peak(1) + peak(nr))
c          wids=poly(x,ndw,aws)
c          nerr = 0
c        else
c          okay = .false.
c          x = peak(linepo+1)
c          wids=poly(x,ndw,aws)
c	  if(widthlist) wids=abs(width(nr+1))
c          do while(.not.okay)
cxxxx
c       endif
c  treat here the case of a search of fit-region
       if(kpeaks.eq.0) then
1	nr=0
2	kpeaks=0
        minreg=0
	backdeg=-1
	if(linepo.ge.maxlin)go to 80
	nerr=0
	x=peak(linepo+1)
	if(x.gt.0)go to 10
	linepo=linepo+1
	nr=linepo
	go to 2
10	wids=poly(x,ndw,aws)
	if(widthlist) wids=abs(width(nr+1))
15	if(nr.eq.0)go to 20
	minreg=-peak(nr)
	maxreg=area(nr)
	backdeg=abs(width(nr)+0.5)
	irange=maxreg-minreg+1
	if(irange.gt.FITREG)go to 20
17	nr=nr+1
	if(nr.gt.maxlin)go to 18
	i=peak(nr)
	if(i.le.0)go to 18
	if(i.gt.maxreg)go to 18
	kpeaks=kpeaks+1
	go to 17
18	if(kpeaks.eq.0)go to 1
	if(kpeaks.le.npeakt)go to 80
20	widp=1.6*wids
	fwid=dble(FITREG)/(2.*wids)
        if(taill .or. tailb .or. tailr .or.lstep) then
	  fwid = min(fwid, 12.)
        else
          fwid = min(fwid, 8.)
        endif
	if(fwid.lt.1.)fwid=1.
	xwid=fwid*wids+widp+0.01
	fwid=xwid
        if(maxch - minch.le.FITREG) then
          if(kpeaks.lt.PEAKTOT) xwid = FITREG
        endif 
	t1 = minreg
	t2 = minch
	minreg=max(x-xwid, t1, t2)
	if(min(maxch,lastch)-minch.lt.FITREG)minreg=minch
	if(linepo.eq.0)go to 30
	y=peak(linepo)
	l=peak(linepo)+widp
	if(minreg.lt.l)minreg=l
c  frage ob abstand der linien gross genug und waehle geignete
c  grenze falls nicht: die grenze wird so gewaehlt, dass die
c  intensitaet der unteren linie 1/3 der von der oberen linie ist
	y=x-y
	if(y.ge.2.*wids)go to 30
	y=0.5*(y-wids*wids*log(3.*area(linepo)/(area(linepo+1)+10.))/y)
	if(y.lt.1.)y=1.
	minreg=x-y
30	kpeaks=1
40	maxreg=min(int(x+xwid), maxch, lastch, minreg+FITREG)
	irange=maxreg-minreg+1
	if(irange.gt.FITREG)go to 50
	if(linepo+kpeaks.ge.maxlin)go to 60
	x=peak(linepo+kpeaks+1)
	if(x.le.0.)go to 60
	if(dble(maxreg).lt.x-widp)go to 60
	kpeaks=kpeaks+1
	if(kpeaks.le.npeakt)go to 40
50	xwid=xwid-0.5*wids
	x=peak(linepo+1)
	if(xwid.gt.wids)go to 30
	i=linepo+1
	j=linepo+kpeaks
	if(lpa)write(3,1045)i,j
	nerr=gaserr(nerr,1)
	linepo=linepo+1
	go to 1
c
c  fuer gammas spektren darf der untergrundsbereich nicht zu
c  gross sein!
60	goto 80
c60	if(.not.tailu) go to 80
c	x=dble(irange)/(fwid*(sqrt(dble(kpeaks))+1.))
c	if(isensw(1))write(3, '('' GASBER: range parameter'',f10.5)') x
cc	if(x-1.29)80,80,50
80	continue
        endif
        if(kpeaks.le.0)then
	  gasber=.false.
	else
	  if(minreg.lt.minsp .or. maxreg.gt.maxsp) then
	    minsp=minreg
	    maxsp=minreg+SPELEN-1
	    i=gasspc(minsp,maxsp,files,spek)
	    if(i.gt.0)maxsp=i
	  end if
          irange = maxreg - minreg + 1
          if(irange.gt.0) then
	    i=0
	    j=minreg-minsp
	    do while (i.lt.irange)
	      i=i+1
	      j=j+1
	      ya(i)=spek(j)
              weight(i) = spekerr(j)
	    end do
	    gasber=.true.
	    peaksadded=0.
          else
            if(lpa) write(3,'(/''GASBER: --> negativ fit range, check ordering of peak sizes'')')
            gasber = .false.
          endif
	end if
	return
1045	format(/'GASBER: lines #',i3,'-',i3,' too close, no fit possible')
	end



